<template>
  <div class="upload-file" :style="{width: maxNums>1?'100%':'auto'}">
    <a-upload
      :action="action"
      :listType="listType"
      :fileList="fileList"
      :disabled="disabled"
      @preview="handlePreview"
      @change="handleChange"
      :beforeUpload="beforeUpload"
      :data="params"
      :value="comVal"
    >
      <div v-if="fileList.length < maxNums && listType=='picture-card'">
        <a-icon type="plus" />
        <div class="ant-upload-text"> {{ upText }}</div>
      </div>
      <div v-if="fileList.length < maxNums && listType!='picture-card'">
        <a-button> <a-icon type="upload" /> {{ upText }} </a-button>
      </div>
    </a-upload>
    <a-modal :visible="previewVisible" :footer="null" @cancel="handleCancel">
      <video v-if="fileType=='video/mp4'" controls="controls" style="width: 100%" :src="previewImage" />
      <img v-else alt="example" style="width: 100%" :src="previewImage" />
    </a-modal>
  </div>
</template>
<script>
export default {
  name: 'Upload',
  props: {
    maxNums: {
      type: Number,
      default: 1
    },
    fileType: {
      type: String,
      default: 'image/jpeg,image/png'
    },
    fileSize: {
      type: Number,
      default: 5
    },
    previewFile: {
      type: Function,
      default: function () {

      }
    },
    action: {
      type: String,
      default: process.env.VUE_APP_API_BASE_URL + '/upload'
    },
    listType: {
      type: String,
      default: 'text'
    },
    upText: {
      type: String,
      default: ''
    },
    value: {
      type: String
    },
    uploadParams: {
      type: Object,
      default: function () {
        return {
          savePathType: 'web' // 存储类型 local 服务器本地，ali 阿里云， web
        }
      }
    },
    disabled: {
      type: Boolean,
      default: false
    }
  },
  watch: {
    value (a, b) {
      this.comVal = a || ''
      if (a == undefined) {
        this.fileList = []
      }
    }
  },
  data () {
    return {
      previewVisible: false,
      previewImage: '',
      fileList: [],
      comVal: this.value,
      params: this.uploadParams
    }
  },
  methods: {
    setFileList (a) {
      const temp = []
      if (a && a.length > 0) {
        a.split(',').map((item, index) => {
          if (item) {
            temp.push({
              uid: index,
              name: item,
              status: 'done',
              url: item,
              response: {
                data: item
              }
            })
          }
        })
      }
      this.fileList = temp
    },
    handleCancel () {
      this.previewVisible = false
    },
    handlePreview (file) {
      if (this.listType == 'text') {
        return
      }
      this.previewImage = file.url || file.thumbUrl
      this.previewVisible = true
    },
    handleChange ({ file, fileList }) {
      if (file.status == 'error') {
        this.$message.error('上传失败，请重试!')
        return
      }
      this.fileList = this.validaFile(file, fileList)
      this.$emit('change', this.formatFile())
      this.$emit('input', this.formatFile())
    },
    // 格式化文件列表数据，给表单
    formatFile () {
      const a = this.fileList
      const temp = []
      if (a && a.length) {
        a.map(item => {
          if (item.response && item.status == 'done') {
            temp.push(item.response.data)
          }
        })
      }
      return temp.join(',')
    },
    // 文件校验
    validaFile (file, filesList) {
      if (filesList.length == 0) {
        return []
      }
      console.log(file, filesList, this.beforeUpload(file, 0))
      if (!this.beforeUpload(file, 0) && file.status != 'removed') {
        const index = filesList.findIndex(item => item.uid == file.uid)
        filesList.splice(index, 1)
      }
      return filesList || []
    },
    // 上传前校验
    beforeUpload (file, tip) {
      // 不限制
      if (this.fileType == '*') {
        return true
      }

      const isType = this.fileType.indexOf(file.type) >= 0 && file.type != ''
      if (!isType) {
        if (tip != 0) {
          this.$message.error('请上传正确的格式!')
        }
        return isType
      }

      // 文件大小
      const isLt2M = file.size / 1024 / 1024 < this.fileSize
      if (!isLt2M) {
        if (tip != 0) {
          if (this.fileType != 'video/mp4') {
            this.$message.error('图片不能超过 ' + this.fileSize + 'MB!')
          } else {
            this.$message.error('视频不能超过 ' + this.fileSize + 'MB!')
          }
        }
        return isLt2M
      }

      return true
    }
  }
}
</script>
<style lang="less">
  .upload-file{
    float: left;
    overflow: hidden;
    height: 80px;
    /* you can make up upload button and sample style by using stylesheets */
    .ant-upload-select-picture-card i {
      font-size: 32px;
      color: #999;
      margin-top: 9px;
    }
    .ant-upload-select-picture-card .ant-upload-text {
      margin-top: 8px;
      color: #666;
    }
    .ant-upload-btn{
      height: 100%;
      >div{
        padding: 4px 0;
      }
    }
    .ant-upload-list-picture-card-container{
      height: 80px;
      width: 80px;
    }
    .ant-upload.ant-upload-select-picture-card,
    .ant-upload-list-picture-card .ant-upload-list-item{
      width:80px;
      height:80px;
      padding: 4px;
      margin: 0;
    }
    .ant-upload-list-item-info{
      padding: 0 22px 0 4px;
    }
    .ant-upload-list-item .anticon-close{
      color: red;
    }
    .ant-upload-list-item-name{
      word-break: break-all;
      white-space: normal;
    }
  }

</style>
